#nolaunch
#launchit v 1.2  (author:a4chitect)
def launch_it
	if(defined? $launchitdlg)
		if($launchitdlg.visible?)
			$launchitdlg.close
			return false
		end
	end
	if !(defined? $launchitcmd)
		launch_it_reload
	end
	#puts $launchitcmd
	functionlist = "var functionlist = Array("
	functionaction = "var functionaction = Array("
	0.upto($launchitcmd.length-1) do |i|
		functionlist = functionlist + "'" + $launchitcmd[i][0].to_s + "',"
		functionaction = functionaction + "'" + $launchitcmd[i][1].to_s + "',"
	end
	functionlist = functionlist.chop + ");"
	functionaction = functionaction.chop + ");"
	
	js_command = functionlist + functionaction
	#puts js_command
	$launchitdlg = UI::WebDialog.new("LaunchIt", false, "LaunchIt Dialog",275, 285, 400, 300,  true)
	path = File.dirname(__FILE__)
	#puts "path=#{path}" 
	$launchitdlg.set_file("A4_launchit.html", path +"/A4_launchit/")
	$launchitdlg.add_action_callback("close_dialog") {
	|d,params|
	d.close
	}
	$launchitdlg.add_action_callback("run_action") {
	|d,params|
	puts params.gsub('|','"')
	eval (params.gsub('|','"'))
	}
	$launchitdlg.show(){
	$launchitdlg.execute_script(js_command)
	}
	#puts js_command
end 

def launch_it_extract
	#code credit goes to Jim Foltz and Alexander Schreyer
	initdir = Sketchup.find_support_file("plugins")
	#savefile = 
	cmdset = []
	begin
    rbfiles = Dir[File.join(initdir, "*.rb")]
		cmdfilepath = File.dirname(__FILE__)+"\\A4_launchit\\plugins.rb"
		cmdfile = File.new(cmdfilepath,"w")
    rbfiles.each {|f|
			submenu = ""
			filecode = File.readlines(f)
			#if(f == "C:/Software/SketchUp7Pro/plugins/A4_launchit.rb")
			if(filecode[filecode.length-1].index('unpack("m").to_s') || filecode[0].index('nolaunch'))
				#puts f.to_s + " is encrypted or not available for launch, was skipped."
			else
				filecode.each {|line|
					#if this line contains the command name/command action combination - extract those and push them into an array for saving later
					if(submenu == "" && line.index('.add_submenu("'))
							substart = line.index('.add_submenu(') + 13
							substart = line.index('"',substart) + 1
							subend = line.index('"',substart)
							#test for found strings
							if (substart && subend)
								submenu = line[substart,subend-substart] + "> "
								#puts f + "  " + submenu
							end
					end
					if(line.index('.add_item("'))
						begin
							namestart = line.index('.add_item(') + 10
							namestart = line.index('"',namestart) + 1
							nameend = line.index('"',namestart)
							actionstart = line.index('{') + 1
							actionend = line.index('}',actionstart)
							#test for found strings
							
							if (namestart && nameend && actionstart && actionend)
								cmdname = line[namestart,nameend-namestart]
								cmdaction = line[actionstart,actionend-actionstart]
							end
							cmdfile.puts %Q($launchitcmd.push [") + submenu + cmdname + %Q(",") + cmdaction + %Q("])
						rescue
							puts f + "> unreadable line: " + line
							puts namestart.to_s + "," + nameend.to_s + "," + actionstart.to_s + "," + actionend.to_s
						end
					end			
				}
			end
		}
		cmdfile.close
  #rescue
  #  puts "could not load any files from Plugins"
  end
	launch_it_reload
end

def launch_it_reload
	#if !(defined? $launchitcmd)
		$launchitcmd = []
	#end
	cmdset = Set.new
	cmdfiles = Dir[File.join(File.dirname(__FILE__) +"/A4_launchit", "*.rb")]
	cmdfiles.each do |tb|
		load tb
	end
	$launchitcmd.uniq!
	$launchitcmd.sort!
end

if (not file_loaded?("A4_launchit.rb") )
  launchitmenu = UI.menu("Plugins").add_submenu("LaunchIt")
	launchitmenu.add_item("LaunchIt") { launch_it }
	launchitmenu.add_item("Reload Plugins") { launch_it_extract }
	
	plugins = Sketchup.find_support_file("Plugins")
	imgdir = File.join(plugins, "A4_launchit")
	# create toolbar
	tb = UI::Toolbar.new("LaunchIt")

	# Toggle console cmd
	cmd = UI::Command.new("LaunchIt") { launch_it }
	cmd.large_icon = File.join(imgdir, "LaunchIt_Large.png")
	cmd.small_icon = File.join(imgdir, "LaunchIt_Small.png")
	cmd.status_bar_text = cmd.tooltip = "Launch plugin by its name"
	tb.add_item cmd
	#again code by Jim Foltz - is this the correct way to join your toolbar proclamation, Jim ?
	tb.restore if tb.get_last_state == TB_VISIBLE
end
file_loaded("A4_launchit.rb")